=== debian/changelog ===
hyprland (0.53.3+ds-4) unstable; urgency=medium

  * Update hyprland-dev dependencies from hyprland.pc
  * Add autopkgtest to ensure that hyprland.pc has all its dependencies

 -- Chow Loong Jin <hyperair@debian.org>  Thu, 19 Feb 2026 11:29:18 +0800

hyprland (0.53.3+ds-3) unstable; urgency=medium

  [ Carl Keinath ]
  * d/patches: use libglaze-dev >= 7.0.0
  * d/clean: update paths
  * d/control:
    - Bump S-V to 4.7.3; drop priority: optional and RRR
    - remove ninja-build and meason
  * d/watch: migrate to version 5
  * d/rules: re-enable hyprpm on big-endian archs

  [ Chow Loong Jin ]
  * d/control:
    - Bump libglaze-dev build-dep version to 7.0.0 (Needed for big-endian
      support)
    - Drop unused build-deps
    - Update hyprland-protocols build-dep version

 -- Chow Loong Jin <hyperair@debian.org>  Wed, 18 Feb 2026 23:31:08 +0800
