=== debian/tests/control ===
Tests: check-hyprland-dev
Depends: @
