=== debian/watch ===
Version: 5

Template: Github
Project: hyprland
Owner: hyprwm
Repack: yes
Repacksuffix: +ds
Dversion-Mangle: auto
