=== hyprpm/CMakeLists.txt ===
--- 
+++ 
@@ -11,9 +11,9 @@
 
 pkg_check_modules(hyprpm_deps REQUIRED IMPORTED_TARGET tomlplusplus hyprutils>=0.7.0)
 
-find_package(glaze 6.0.0 QUIET)
+find_package(glaze 7.0.0 QUIET)
 if (NOT glaze_FOUND)
-    set(GLAZE_VERSION v6.1.0)
+    set(GLAZE_VERSION v7.0.0)
     message(STATUS "glaze dependency not found, retrieving ${GLAZE_VERSION} with FetchContent")
     include(FetchContent)
     FetchContent_Declare(
@@ -21,6 +21,7 @@
         GIT_REPOSITORY https://github.com/stephenberry/glaze.git
         GIT_TAG ${GLAZE_VERSION}
         GIT_SHALLOW TRUE
+        EXCLUDE_FROM_ALL
     )
     FetchContent_MakeAvailable(glaze)
 endif()
