=== debian/changelog ===
hyprland (0.54.0+ds-1) unstable; urgency=medium

  * New upstream version 0.54.0+ds
  * Drop upstreamed patches and refresh the rest

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 02 Mar 2026 15:30:17 +0800
